let pwdPrompt
let pwdPromptInfoBody
let pwdPromptlilist
let pwdPromptScoreBarEntity
let pwdPromptStrongDescSpan





function setPwdPromptLiState(value,state) {
    switch (state) {
        case 0:
            pwdPromptlilist.children().eq((value-1)).removeClass("pwdPrompt_right_ul_li_circle_yes")
            break
        case 1:
            pwdPromptlilist.children().eq((value-1)).addClass("pwdPrompt_right_ul_li_circle_yes")
            break
    }

}

function setPwdPromptBar(value) {
    let bourn
    let str
    let color
    switch (value) {
        case 0:
            bourn = "0px"
            str = ""
            color='#fcfffa'
            break
        case 1:
            bourn = "100px"
            str ="弱";
            color='#ff3a29'
            break
        case 2:
            bourn="200px"
            str="中等"
            color='#ffd42b'
            break
        case 3:
            bourn="290px"
            str="强壮"
            color='#32ff5a'
            break
        case 4:
            bourn="322px"
            str="强壮"
            color='#1cff49'
            break
    }
    pwdPromptScoreBarEntity.stop()
    pwdPromptScoreBarEntity.animate({
        width:bourn,
        backgroundColor:color
    },300,function () {
        setPwdPromptStrongDescSpan(str)
    })
}
function setPwdPromptStrongDescSpan(str) {
    pwdPromptStrongDescSpan.children(":first").text(str)
}


function isSpecial(str){
    let result = true
    let patrn=/[\u4E00-\u9FA5]|[\uFE30-\uFFA0]/gi;
    if(!patrn.exec(str)){
        result = false;
    }


    if(str.indexOf(" ") != -1){
        result = true
    }

    if(isEmojiCharacter(str)){
        result = true
    }



    return result
}

function assessPwdMel1(pwd) {

    if(pwd.length > 32){
        setPwdPromptInfoBody(pwdPromptInfoEntityList[201])
        setPwdPromptBar(0)
        return false
    }

    if(isSpecial(pwd)){
        setPwdPromptInfoBody(pwdPromptInfoEntityList[203])
        setPwdPromptBar(0)
        return false
    }
    if(checkContinueRepeChar(pwd)){
        setPwdPromptInfoBody(pwdPromptInfoEntityList[202])
        setPwdPromptBar(0)
        return false
    }
    setPwdPromptInfoBody(pwdPromptInfoEntityList[200])
    return true
}


function assessPwdMel2(pwd) {
    let result = true
    {
        if(pwd.length >= 10){
            setPwdPromptLiState(1,1)
        }else{
            setPwdPromptLiState(1,0)
            result = false
        }
    }
    {
        if(/[a-z]/.test(pwd) && /[A-Z]/.test(pwd)){
            setPwdPromptLiState(3,1)

        }else{
            setPwdPromptLiState(3,0)
            result = false
        }
    }
    {
        if(/\d+/.test(pwd)){
            setPwdPromptLiState(5,1)

        }else{
            setPwdPromptLiState(5,0)
            result = false
        }
    }
    return result
}

function gradePwd(pwd) {

    let lv = 2

    let count = charSpecialCount(pwd)

    if(count >= 1){
        lv++
    }
    if(count >=4){
        lv++
    }
    return lv
}

function charSpecialCount(pwd) {
    let count = 0
    for (let i = 0; i < pwd.length; i++) {
        if(/[~#^$@%&!?%.*';{}/<>[]/gi.test(pwd[i]) ){
            count++
        }
    }
    return  count
}

function checkContinueRepeChar(pwd) {
    let count = 1
    for (let i = 0; i < pwd.length; i++) {
        if(count >= 3){
            return true
        }
        if(i != pwd.length){
            if(pwd[i] == pwd[i+1] ){
                count ++
                continue
            }else{
                count = 1
                continue
            }
        }
    }
    return false
}

function showPwdPrompt() {
    pwdPrompt.show(500)
}
function hidePwdPrompt() {
    pwdPrompt.hide(500)
}



function renovatePwdPromptState(el) {

    let pwd = el.value

    if(assessPwdMel1(pwd) == false){
        setPwdPromptBar(0)
        console.log(false)
        return false

    }
    if(assessPwdMel2(pwd) == false){
        let lv = pwd.length>=1?1:0
        setPwdPromptBar(lv)
        console.log(false)
        return false
    }

    setPwdPromptBar(gradePwd(pwd,true))
    console.log(true)
    return true;
}

function setPwdPromptInfoBody(entity) {
    pwdPromptInfoBody.html(entity.body)

}
function isEmojiCharacter(substring) {
    for (var i = 0; i < substring.length; i++) {
        var hs = substring.charCodeAt(i);
        if (0xd800 <= hs && hs <= 0xdbff) {
            if (substring.length > 1) {
                var ls = substring.charCodeAt(i + 1);
                var uc = ((hs - 0xd800) * 0x400) + (ls - 0xdc00) + 0x10000;
                if (0x1d000 <= uc && uc <= 0x1f77f) {
                    return true;
                }
            }
        } else if (substring.length > 1) {
            var ls = substring.charCodeAt(i + 1);
            if (ls == 0x20e3) {
                return true;
            }
        } else {
            if (0x2100 <= hs && hs <= 0x27ff) {
                return true;
            } else if (0x2B05 <= hs && hs <= 0x2b07) {
                return true;
            } else if (0x2934 <= hs && hs <= 0x2935) {
                return true;
            } else if (0x3297 <= hs && hs <= 0x3299) {
                return true;
            } else if (hs == 0xa9 || hs == 0xae || hs == 0x303d || hs == 0x3030
                || hs == 0x2b55 || hs == 0x2b1c || hs == 0x2b1b
                || hs == 0x2b50) {
                return true;
            }
        }
    }
}

window.onload = function () {


}
function pwdPromptinit() {
    pwdPrompt = $(document.getElementById("pwdPrompt"))
    pwdPromptInfoBody = $(document.getElementById("pwdPrompt").getElementsByClassName("pwdPrompt_right_info")[0])
    pwdPromptlilist = $(document.getElementById("pwdPrompt").getElementsByClassName("pwdPrompt_right_ul_li"))
    pwdPromptScoreBarEntity = $(document.getElementById("pwdPrompt").getElementsByClassName("pwdPrompt_right_scorebar_entity")[0])
    pwdPromptStrongDescSpan = $(document.getElementById("pwdPrompt").getElementsByClassName("pwdPrompt_right_strongDesc_p_span")[0])
}